<?php
/**************************************************
  Coppermine 1.4.x Plugin - Right Click Menu
  *************************************************
  Copyright (c) 2006 Borzoo Mossavari
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  *************************************************
  This is a simple Advertisement plugin without statistics
  or any kind of log.
  this will give you flash/picture/HTML banner
  By using FRAME technology
  ***************************************************/
  
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Add an install & configure & uninstall actions
$thisplugin->add_action('plugin_install','rcmenu_install');
$thisplugin->add_action('plugin_configure','rcmenu_configure');
$thisplugin->add_action('plugin_uninstall','rcmenu_uninstall');
$thisplugin->add_action('plugin_cleanup','rcmenu_cleanup');

// Add the main filter - Add Menu to the page
$thisplugin->add_filter('page_html','rc_menu');

// Add actions
$thisplugin->add_action('page_start','rcmenu_page_start');

// Install Plugin
function rcmenu_install() 
{
	global $CONFIG, $lang_plugin_rcmenu, $lang_plugin_rcmenu_config, $lang_plugin_rcmenumgr, $thisplugin;
	require ('plugins/rcmenu/include/init.inc.php');
	if ($_POST['submit']==$lang_plugin_rcmenu_config['button_install']) {
		require 'include/sql_parse.php';
		// create table	
		$db_schema = $thisplugin->fullpath . '/schema.sql';
		$sql_query = fread(fopen($db_schema, 'r'), filesize($db_schema));
		$sql_query = preg_replace('/CPG_/', $CONFIG['TABLE_PREFIX'], $sql_query);

		$sql_query = remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, ';');
		
		foreach($sql_query as $q) { 
			cpg_db_query($q);
		}
		return true;
	} else {
		return 1;
	}
}

// Configure Plugin
function rcmenu_configure() 
{
	global $CONFIG, $lang_plugin_rcmenu, $lang_plugin_copperad_rcmenu,$lang_plugin_rcmenumgr;
	require ('plugins/rcmenu/include/init.inc.php');

	echo <<< EOT
		<h2>{$lang_plugin_rcmenu['install_click']}</h2>
		{$lang_plugin_rcmenu['install_note']}<br />
		<br />
		<form action="{$_SERVER['REQUEST_URI']}" method="post">
		<input type="submit" value="{$lang_plugin_rcmenu_config['button_install']}" name="submit" />
		</form>
EOT;
}

// Uninstall (ask admin about dropping table)
function rcmenu_uninstall()
{
	global $CONFIG, $thisplugin;
	
	if (!isset($_POST['drop'])) return 1;
	
	if ($_POST['drop']) {
		cpg_db_query("DROP TABLE IF EXISTS {$CONFIG['TABLE_PLUGIN_RCMENU']}");
   	}

	return true;
}

// Ask if admin wants to drop the table
function rcmenu_cleanup($action) 
{
    global $lang_plugin_rcmenu_config;
    require ('plugins/rcmenu/include/init.inc.php');

    if ($action===1) {
        echo <<< EOT
    <form action="{$_SERVER['REQUEST_URI']}" method="post">
        <p>
            {$lang_plugin_rcmenu_config['cleanup_question']}
        </p>
        <div style="margin:25;">
        <table border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td><input type="radio" name="drop" value="1" /></td>
                <td>Yes</td>
            </tr>
            <tr>
                <td><input type="radio" name="drop" checked="checked" value="0" /></td>
                <td>No</td>
            </tr>
        </table>
        </div>
        <span>
           <input type="submit" name="submit" value="{$lang_plugin_rcmenu_config['button_submit']}" /> &nbsp;&nbsp;&nbsp;
            <input type="button" name="cancel" onClick="window.location='pluginmgr.php';" value="{$lang_plugin_rcmenu_config['button_cancel']}" />
        </span>
    </form>
EOT;
    }
}

// add config button
function rcmenu_add_config_button($href,$title,$target,$link)
{
  global $template_gallery_admin_menu;

  $new_template = $template_gallery_admin_menu;
  $button = template_extract_block($new_template,'documentation');
  $params = array(
      '{DOCUMENTATION_HREF}' => $href,
      '{DOCUMENTATION_TITLE}' => $title,
      'target="cpg_documentation"' => $target,
      '{DOCUMENTATION_LNK}' => $link,
   );
   $new_button="<!-- BEGIN $link -->".template_eval($button,$params)."<!-- END $link -->\n";
   template_extract_block($template_gallery_admin_menu,'documentation',"<!-- BEGIN documentation -->" . $button . "<!-- END documentation -->\n" . $new_button);
}

// add admin button to start of each page
function rcmenu_page_start()
{
	global $CONFIG, $lang_plugin_rcmenu, $lang_plugin_rcmenu_config, $lang_plugin_rcmenumgr, $RCMENU;
	require ('plugins/rcmenu/include/init.inc.php');
	$RCMENU = cpg_db_query("SELECT * FROM {$CONFIG['TABLE_PREFIX']}plugin_rcmenu order by id");
	$CONFIG['TABLE_PLUGIN_RCMENU'] = $CONFIG['TABLE_PREFIX'].'plugin_rcmenu';

	if (GALLERY_ADMIN_MODE) {
		rcmenu_add_config_button('index.php?file=rcmenu/rcmenumgr',$lang_plugin_rcmenu['config_title'],'',$lang_plugin_rcmenu['config_button']);
	}
}

// Add Righ Click Menu
function rc_menu($html) 
{
	global $CONFIG, $RCMENU;
$rightclickstyle='</title><STYLE TYPE="text/css">
   .rcMenu{
   position: absolute;
   visibility:hidden;
   cursor: default;
   color: menutext;
   width: 165px;
   background-color: menu;
   border:2px threedhighlight outset;
   font-family:MS Sans Serif;
   font-size:8pt;
   z-index:40;
}

.menuitems{
   padding-left:15px;
   padding-right:10px;
   padding-bottom:1px;
}

</STYLE></head>
';
$rcscript='</title>
<SCRIPT LANGUAGE="JavaScript">
<!-- // RightClickMenu

function showmenuie5(){
		var rightedge=document.body.clientWidth-event.clientX
		var bottomedge=document.body.clientHeight-event.clientY
		if (rightedge<ie5menu.offsetWidth) {
			if(document.body.scrollLeft>0)
				ie5menu.style.left=document.body.scrollLeft+event.clientX-ie5menu.offsetWidth
			else
				ie5menu.style.left=document.documentElement.scrollLeft+event.clientX-ie5menu.offsetWidth
		}
		else {
			if(document.body.scrollLeft>=0)
				ie5menu.style.left=document.body.scrollLeft+event.clientX
			else
				ie5menu.style.left=document.documentElement.scrollLeft+event.clientX
		}
		if (bottomedge<ie5menu.offsetHeight) {
			if(document.body.scrollTop>0)
				ie5menu.style.top=document.body.scrollTop+event.clientY-ie5menu.offsetHeight
			else
				ie5menu.style.top=document.documentElement.scrollTop+event.clientY-ie5menu.offsetHeight
		}
		else {
			if(document.body.scrollTop>0)
		 		ie5menu.style.top=document.body.scrollTop+event.clientY
			else
		 		ie5menu.style.top=document.documentElement.scrollTop+event.clientY

		}
		ie5menu.style.visibility="visible"
		return false
}
function hidemenuie5(){
		ie5menu.style.visibility="hidden"
}
function hidemenuie5(){
		ie5menu.style.visibility="hidden"
}
function highlightie5(){
		if (event.srcElement.className=="menuitems"){
			event.srcElement.style.backgroundColor="highlight"
			event.srcElement.style.color="white"
		}
}
function lowlightie5(){
		if (event.srcElement.className=="menuitems"){
			event.srcElement.style.backgroundColor=""
			event.srcElement.style.color="black"
		}
} 
function jumptoie5(){
		if (event.srcElement.className=="menuitems"){
			if (event.srcElement.url != \'\'){
				if (event.srcElement.getAttribute("target")!=null)
					window.open(event.srcElement.url,event.srcElement.getAttribute("target"))
				else
					window.location=event.srcElement.url
			}
		}
}
// -->
</SCRIPT>';
	while ($row=mysql_fetch_assoc($RCMENU)){
		if($row['hrnext']=='1'&& $row['admin']==0) {
			$menu=$menu.'<div class="menuitems" url="'.$row['url'].'" target="'.$row['target'].'">'.$row['title'].'</div><HR>';
		} else if($row['hrnext']=='0'&& $row['admin']==0){
					$menu=$menu.'<div class="menuitems" url="'.$row['url'].'" target="'.$row['target'].'">'.$row['title'].'</div>';
		} else if (GALLERY_ADMIN_MODE && $row['admin']==1 && $row['hrnext']=='1') {
					$menu=$menu.'<div class="menuitems" url="'.$row['url'].'" target="'.$row['target'].'">'.$row['title'].'</div><HR>';
		} else if (GALLERY_ADMIN_MODE && $row['admin']==1 && $row['hrnext']=='0') {
						$menu=$menu.'<div class="menuitems" url="'.$row['url'].'" target="'.$row['target'].'">'.$row['title'].'</div>';
		}
}
	$premenu='<body><RightClick>
    <!--[if IE]>
<div id="ie5menu" class="rcMenu" onMouseover="highlightie5()" onMouseout="lowlightie5()" onClick="jumptoie5()">
';
	$postmenu='<![endif]--></div>
    <script language="JavaScript">
<!--
if (document.all&&window.print){
	ie5menu.className="rcMenu"
	document.oncontextmenu=showmenuie5
	document.body.onclick=hidemenuie5
}
//-->
  </script>
 </RightClick>';
    $menu_template=$premenu.$menu.$postmenu;
	$html = ereg_replace('<body>',$menu_template,$html);
	$html = ereg_replace('</title>',$rightclickstyle,$html);
	$html = ereg_replace('</head>',$rcscript,$html);

	return $html;
}
?>